// GigeDemoDlg.cpp : implementation file
//
// #include <windows.h>
#include "stdafx.h"
#include "GigeDemo.h"
#include "GigeDemoDlg.h"
#include "okapi32.h"
#include <winsock.h>
#include "SelectBoard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HANDLE				hBoard; //
LPBITMAPINFOHEADER	lpbi;
LPBYTE				lpdib;
BLOCKINFO			blk;
HWND				hWnd;
RECT				rect;
BOOL				saveimage = FALSE, bActive = FALSE, bSetIp = FALSE; //ͼɼ־
long				totalframe=0; //ܲɼ֡
float				ratio=0;
long				num=0;
OKDEVTYPE           *lpOkDevInfo;
extern int			OpenBoardNo;
int					TotalBoard = 0; //
int                 iCx, iCy;
bool                bInitFinish = FALSE; //Ƿɳʼ

BOOL CALLBACK BeginCapture(HANDLE hBoard);
BOOL CALLBACK Process(HANDLE hBoard, long no);
BOOL CALLBACK EndCapture(HANDLE hBoard);
float exCalcCaptureRatio();
BOOL exGetSaveName(HWND hWnd, char *szFileName);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGigeDemoDlg dialog

CGigeDemoDlg::CGigeDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGigeDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGigeDemoDlg)
	m_ccdgain = 0;
	m_exposetime = 0;
	m_width = 0;
	m_height = 0;
	m_mode = -1;
	m_brightness = 0;
	m_PacketSize = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGigeDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGigeDemoDlg)
	DDX_Control(pDX, IDC_IPADDRESS1, m_ipaddress);
	DDX_Control(pDX, IDC_BUFFERFORMAT, m_bufform);
	DDX_Control(pDX, IDC_IMAGE, m_image);
	DDX_Text(pDX, IDC_CCDGAIN, m_ccdgain);
	DDV_MinMaxInt(pDX, m_ccdgain, 0, 255);
	DDX_Text(pDX, IDC_EXPOSETIME, m_exposetime);
	DDX_Text(pDX, IDC_WIDTH, m_width);
	DDV_MinMaxInt(pDX, m_width, 0, 1360);
	DDX_Text(pDX, IDC_HEIGHT, m_height);
	DDV_MinMaxInt(pDX, m_height, 0, 1024);
	DDX_Radio(pDX, IDC_FREEMODE, m_mode);
	DDX_Text(pDX, IDC_BRIGHTNESS, m_brightness);
	DDV_MinMaxInt(pDX, m_brightness, 0, 255);
	DDX_Text(pDX, IDC_PACKETSIZE, m_PacketSize);
	DDV_MinMaxLong(pDX, m_PacketSize, 8, 2048);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGigeDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CGigeDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CAPTUREIMAGE, OnCaptureImage)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_SETPARAM, OnSetParam)
	ON_BN_CLICKED(IDC_ORGSET, Onorgset)
	ON_BN_CLICKED(IDC_SAVEIMAGE, Onsaveimage)
	ON_BN_CLICKED(IDC_REOPEN, OnReOpen)
	ON_BN_CLICKED(IDC_SOFTTRIGGER, OnSoftTrigger)
	ON_NOTIFY(IPN_FIELDCHANGED, IDC_IPADDRESS1, OnFieldchangedIpaddress1)
	ON_BN_CLICKED(IDC_SAVETOMEMORY, OnSavetomemory)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGigeDemoDlg message handlers

long exSetBitmapHeader(LPBITMAPINFOHEADER lpbi,short width,short height, short bits, short form)
{
	long	wbytes;
	
	if(!lpbi)
		return FALSE;
	
	if(form==FORM_RGB555)
		bits=16;
	wbytes=((((width*bits)+31)&~31)>>3);//bmp need 4 byte align
	
	lpbi->biWidth=width;
	lpbi->biHeight=height;
	
	lpbi->biSize=sizeof(BITMAPINFOHEADER);
	lpbi->biPlanes=1;
	
	lpbi->biBitCount=bits;
	lpbi->biSizeImage=wbytes*height;
	
	
	lpbi->biClrUsed=0;
	//special format for 555,565 & 32 
	if(form==FORM_RGB555 || form==FORM_RGB565 || form==FORM_RGB8888 ) 
		lpbi->biCompression=BI_BITFIELDS;
	else
		lpbi->biCompression=0;
	if(lpbi->biCompression==BI_BITFIELDS ) {//
		DWORD	*lpmask;
		lpmask=(DWORD *)((LPSTR)lpbi+lpbi->biSize);
		
		if(form==FORM_RGB555) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x03e0;
			lpmask[0]=0x7c00;
		}
		else if(form==FORM_RGB565) {
			lpmask[2]=0x001f; //blue
			lpmask[1]=0x07e0;
			lpmask[0]=0xf800;
		}
		else if(bits==32 ) {
			lpmask[2]=0x0000ff;
			lpmask[1]=0x00ff00;
			lpmask[0]=0xff0000;
		}
	}
	else if(bits<=14) { // 8,10,12
		int		i,ratio;
		RGBQUAD	*lpRGB=(RGBQUAD *)((LPSTR)lpbi+lpbi->biSize);
		
		lpbi->biClrUsed=(1<<bits);
		ratio=lpbi->biClrUsed/256;
		
		for(i=0; i<(short)lpbi->biClrUsed;i++) {
			lpRGB[i].rgbBlue=i/ratio;
			lpRGB[i].rgbGreen=i/ratio;
			lpRGB[i].rgbRed=i/ratio;
			lpRGB[i].rgbReserved=0;
		}
	} 
	lpbi->biClrImportant=lpbi->biClrUsed;
	
	return lpbi->biClrUsed;
}

long exGetTargetSize(HANDLE hBoard, TARGET tgt, short *width, short *height)
{
	RECT	rect;
	long	form;
	if ( (tgt == SCREEN ) || (tgt == BUFFER) )
	{
		rect.right = -1;
		okSetTargetRect(hBoard, tgt, &rect); //get current rect
		if(width)
			*width = (short)(rect.right-rect.left);
		if(height)
			*height=(short)(rect.bottom-rect.top);
		if(tgt==SCREEN ) 
		{
			form=okSetCaptureParam(hBoard,CAPTURE_SCRRGBFORMAT,GETCURRPARAM); //-1
			//limit to video rect
			rect.right=-1; //max. captured rect
			okSetTargetRect(hBoard,VIDEO,&rect); //get video rect
			if(width)
				*width=(short)min(*width,rect.right-rect.left);
			if(height)
				*height=(short)min(*height,rect.bottom-rect.top);
		}
		else if(tgt==BUFFER) 
			form=okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,GETCURRPARAM); //-1
		
	} else if(tgt>BUFFER)
	{ //from blkinfo
		LPBLOCKINFO	lpblk;
		lpblk=(LPBLOCKINFO)tgt;
		
		if(width)
			*width=lpblk->iWidth;
		if(height)
			*height=abs(lpblk->iHeight);
		form=MAKELONG(lpblk->iFormType,lpblk->iBitCount);
	}
	
	return form;
}

BOOL exGetSaveName(HWND hWnd, char *szFileName)
{
	OPENFILENAME ofn;	 
	char		*szFilter=
		"BMP file (*.BMP)\0*.BMP\0"
		"Jpeg format file (*.JPG)\0*.JPG\0"
		"Sequence file (*.SEQ)\0*.SEQ\0"
		"Sequence file in JPEG (*.SEQ)\0*.SEQ\0"
		"Audio-video interleaved (*.AVI)\0*.AVI\0"
		"Compressed AVI in MJPEG  (*.AVI)\0*.AVI\0"
		"Compressed AVI in MPEG4  (*.AVI)\0*.AVI\0"
		"Raw format files (*.RAW)\0*.RAW\0";
	
    //Get file name
	// fill in non-variant fields of OPENszFileName struct. 
    ZeroMemory(&ofn,sizeof(OPENFILENAME));
    ofn.lStructSize		= sizeof(OPENFILENAME);
    ofn.hwndOwner	  	= hWnd;
    ofn.lpstrFilter 	= szFilter;
	ofn.nFilterIndex	= 1;
    ofn.lpstrFile	  	= szFileName;
    ofn.nMaxFile	  	= 128;
	ofn.lpstrDefExt		= "seq";
	
    ofn.Flags		  	= OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	
    if (!GetSaveFileName((LPOPENFILENAME)&ofn)) 
	{
		return FALSE;
	}
	
	if( !strnicmp(strrchr(szFileName,'.'),".seq",4) ||
		!strnicmp(strrchr(szFileName,'.'),".avi",4) ||
		!strnicmp(strrchr(szFileName,'.'),".m2v",4) 
		)  
	{
		//first delete ok.seq or .avi
		DeleteFile(szFileName);							
	}
	
	if(ofn.nFilterIndex==4) 
	{ //seq file in jpeg data
		strcat(szFileName,",jpg,50"); //quality=50
	}
	else if(ofn.nFilterIndex==6) 
	{ //avi in mjpg
		strcat(szFileName,",mjpg,60"); //mjpeg
	}
	else if(ofn.nFilterIndex==7) 
	{ //avi in mpeg4
		strcat(szFileName,",mpg4"); //mpeg4
	}
	
	return TRUE;
}

BOOL CGigeDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	CRect imagerect;  
	/////////////////////////////////////////////////////imageؼλ	
	GetDlgItem(IDC_IMAGE)->GetWindowRect(&imagerect);	
	ScreenToClient(&imagerect);
	GetDlgItem(IDC_IMAGE)->MoveWindow(imagerect.left, imagerect.top, 640, 480, true);

    /////////////////////////////////////////////////////////////////////
	lpbi = (LPBITMAPINFOHEADER)GlobalAlloc(GPTR, 1300*1024*8+5120);
	lpdib = (LPBYTE)lpbi + 5120;
	hWnd = AfxGetApp()->m_pMainWnd->m_hWnd;
	////////////////////////////////////////////////////////////////////
 	GetDlgItem(IDC_ORGSET)->EnableWindow(FALSE);
 	GetDlgItem(IDC_CAPTUREIMAGE)->EnableWindow(FALSE);
    GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_SOFTTRIGGER)->EnableWindow(FALSE);
    GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(FALSE);
    GetDlgItem(IDC_SETPARAM)->EnableWindow(FALSE);
    GetDlgItem(IDC_SAVETOMEMORY)->EnableWindow(FALSE);
	
	bInitFinish = TRUE;


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGigeDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGigeDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDC *cdc;
		RECT rect;
		
		cdc = m_image.GetDC();
		
		m_image.GetClientRect(&rect);
		SetStretchBltMode(cdc->m_hDC, STRETCH_DELETESCANS);
		okWaitVerticalSync(hBoard, 0);
		StretchDIBits(cdc->m_hDC,
			rect.left, rect.top,
			rect.right, rect.bottom, 
			0, 0, //horzstart, vertstart, 
			lpbi->biWidth, lpbi->biHeight,
			lpdib, (LPBITMAPINFO)lpbi, 
			DIB_RGB_COLORS, SRCCOPY);
		
 		ReleaseDC(cdc);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGigeDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGigeDemoDlg::OnCaptureImage() //ɼ/ʾ
{
	// TODO: Add your control notification handler code here
	okSetSeqCallback(hBoard, BeginCapture, Process, EndCapture);//ûص
	if (okCaptureTo(hBoard, BUFFER, 0, -1))//ɼ
	{
		bActive = TRUE; 
	}	
	GetDlgItem(IDC_CAPTUREIMAGE)->EnableWindow(FALSE);//ɼťЧ
	GetDlgItem(IDC_STOP)->EnableWindow(TRUE);//ֹͣťЧ
}

void CGigeDemoDlg::OnStop() //ֹͣ
{
	// TODO: Add your control notification handler code here
	okStopCapture(hBoard); //ֹͣɼ
	bActive = FALSE;
	GetDlgItem(IDC_CAPTUREIMAGE)->EnableWindow(TRUE); //ɼťЧ
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE); //ֹͣťЧ
}

BOOL CALLBACK BeginCapture(HANDLE hBoard)
{
	short	width, height;
	long	form;

	exGetTargetSize(hBoard, BUFFER, &width, &height);
	form = okSetCaptureParam(hBoard, CAPTURE_SCRRGBFORMAT, GETCURRPARAM); //-1
	exSetBitmapHeader(lpbi, width, height, HIWORD(form), LOWORD(form));
	blk.lpBits = lpdib;
	blk.iBitCount = lpbi->biBitCount;
	blk.iHeight = -(short)lpbi->biHeight;
	blk.iWidth = (short)lpbi->biWidth;
	
	return 1;
}

BOOL CALLBACK Process(HANDLE hBoard,long no)
{	
	char	strratio[256]="\0";
    char	szFileName[128]="\0";

	if (saveimage) //ͼʱ滺еͼ
	{
        exGetSaveName(hWnd, szFileName);
		okSaveImageFile(hBoard, szFileName, 0, BUFFER, no, 1);
		saveimage = FALSE;
	}
	okConvertRect(hBoard, (TARGET)&blk, 0, BUFFER, no, 1);
	sprintf(strratio, "GigeDemo  Ratio = %5.2f; Total frames = %6i; Current = %6i ", exCalcCaptureRatio(), totalframe, no);
	SetWindowText(hWnd, strratio);
	GetWindowRect(GetDlgItem(hWnd, IDC_IMAGE), &rect);
	ScreenToClient(hWnd, (LPPOINT)&rect);
 	InvalidateRect(hWnd, &rect, FALSE);
	totalframe++; //ܲɼ֡
	return 1;
}

BOOL CALLBACK EndCapture(HANDLE hBoard)
{
	okSetSeqCallback(hBoard, NULL, NULL, NULL);
	return 1;
}

void CGigeDemoDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	okStopCapture(hBoard);
	okCloseBoard(hBoard);
	GlobalFree(lpbi);

	CDialog::OnClose();
}

void CGigeDemoDlg::OnSetParam() //
{
	// TODO: Add your control notification handler code here
	///////////////////////////////////////////////////////////////RGBʽ
	if (bActive)
	{
		OnStop(); //ֹͣɼ
	}
	UpdateData(TRUE);
    switch (m_bufform.GetCurSel())//ѻRGBʽRGBʽһ
    {
	case 0:
		okSetVideoParam(hBoard, VIDEO_RGBFORMAT, FORM_GRAY8);
		okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY8);
		break;
	case 1:
		okSetVideoParam(hBoard, VIDEO_RGBFORMAT, FORM_GRAY10);
		okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY10);
		break;
	case 2:
		okSetVideoParam(hBoard, VIDEO_RGBFORMAT, FORM_GRAY12);
		okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY12);
		break;
	case 3:
		okSetVideoParam(hBoard, VIDEO_RGBFORMAT, FORM_GRAY14);
		okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY14);
		break;
	case 4:
		okSetVideoParam(hBoard, VIDEO_RGBFORMAT, FORM_GRAY16);
		okSetCaptureParam(hBoard, CAPTURE_BUFRGBFORMAT, FORM_GRAY16);
		break;
	default:
		break;
    }
//////////////////////////////////////////////////////////////
	okSetVideoParam(hBoard, VIDEO_CONTRAST, m_ccdgain);
///////////////////////////////////////////////////////////////عʱ
	okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, m_exposetime);
	m_exposetime = okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, -1);
///////////////////////////////////////////////////////////////С
	okSetCaptureParam(hBoard, CAPTURE_PACKETSIZE, m_PacketSize); 
///////////////////////////////////////////////////////////////ģʽ
	switch (m_mode)
	{
	case 0:
		okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, MAKELONG(0,0));//
		GetDlgItem(IDC_SOFTTRIGGER)->EnableWindow(FALSE);
		break;
	case 1:
		okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, MAKELONG(0,1));//ش
		GetDlgItem(IDC_SOFTTRIGGER)->EnableWindow(TRUE);
		break;
	case 2:
		okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, MAKELONG(0,2));//崥
		break;
	case 3:
		okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, MAKELONG(0,3));//ͬ
		break;
	}
///////////////////////////////////////////////////////////////ڵƽ
		okSetVideoParam(hBoard, VIDEO_BRIGHTNESS, m_brightness);
		m_brightness = okSetVideoParam(hBoard, VIDEO_BRIGHTNESS, -1);
///////////////////////////////////////////////////////////////
		if ((m_width <= LOWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1)))&&(m_height <= HIWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1))))
		{
			SetRect(&rect, 0, 0, m_width, m_height);
		    okSetTargetRect(hBoard, BUFFER, &rect);//Set Buffer Rect
		}
		else
		{
			m_width = LOWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1));
			m_height = HIWORD(okSetVideoParam(hBoard, VIDEO_AVAILRECTSIZE, -1));
            SetRect(&rect, 0, 0, m_width, m_height);
		    okSetTargetRect(hBoard, BUFFER, &rect);//Set Buffer Rect
		}		
///////////////////////////////////////////////////////////////ip
		if (bSetIp)
		{
			NETCFGPARAM		NetCfgParam;		
			BYTE	bIP1 = 0;
			BYTE	bIP2 = 0;
			BYTE	bIP3 = 0;
			BYTE	bIP4 = 0;
			m_ipaddress.GetAddress(bIP1, bIP2, bIP3, bIP4);
			
			NetCfgParam.bRWFlag = 1; //01д
			sprintf(NetCfgParam.szAddress, "%d.%d.%d.%d",bIP1,bIP2,bIP3,bIP4);
			okSetDeviceParam(hBoard, DEVICE_SETIPADDRESS, (long)&NetCfgParam);            
			bSetIp = FALSE;
		}
		UpdateData(FALSE);
}

void CGigeDemoDlg::Onorgset()//ʼ 
{
	// TODO: Add your control notification handler code here
    DWORD orghor,orgver,rectshift;
	WORD orgwidth,orgheight,xshift,yshift;
	int mBufRgbFrom;
    OnStop();	//ֹͣ
    okSetVideoParam(hBoard,VIDEO_RESETALL,0);
	okSetCaptureParam(hBoard,CAPTURE_RESETALL,0);
	okSetConvertParam(hBoard,CONVERT_RESETALL,0);

	orghor=okSetCaptureParam(hBoard,CAPTURE_HORZPIXELS,-1);//õˮƽܲɼ
	orgver=okSetCaptureParam(hBoard,CAPTURE_VERTLINES,-1);//õֱܲɼ
    rectshift=okSetVideoParam(hBoard,VIDEO_RECTSHIFT,0); //õƫ
	xshift=LOWORD(rectshift);
	yshift=HIWORD(rectshift);
	orgwidth=orghor-xshift;
	orgheight=orgver-yshift;
	SetRect(&rect,0,0,orgwidth,orgheight);
	okSetTargetRect(hBoard,BUFFER,&rect);
///////////////////////////////////////////////////////////////////////
	m_width=rect.right-rect.left;
	m_height=rect.bottom-rect.top;
    m_mode=okSetCaptureParam(hBoard,CAPTURE_TRIGCAPTURE,-1); //ģʽ
	m_ccdgain=okSetVideoParam(hBoard,VIDEO_CONTRAST,-1); //
    m_brightness=okSetVideoParam(hBoard,VIDEO_BRIGHTNESS,-1); //
	m_exposetime=okSetCaptureParam(hBoard,CAPTURE_EXPOSETIME,-1); //عʱ
	mBufRgbFrom = okSetCaptureParam(hBoard,CAPTURE_BUFRGBFORMAT,-1); //RGBʽ
	switch (mBufRgbFrom)
    {
	case FORM_GRAY8:
		m_bufform.SetCurSel(0);
		break;
	case FORM_GRAY10:
		m_bufform.SetCurSel(1);
		break;
	case FORM_GRAY12:
		m_bufform.SetCurSel(2);
		break;
	case FORM_GRAY14:
		m_bufform.SetCurSel(3);		
		break;
	case FORM_GRAY16:
		m_bufform.SetCurSel(4);
		break;
	default:
		break;	
	}    
	UpdateData(FALSE);
}

void CGigeDemoDlg::Onsaveimage()//õͼ·Լļ 
{
	// TODO: Add your control notification handler code here
	if (bActive)
	{
		saveimage = TRUE;
	}
	else
	{
		char szFileName[128]="\0"; 
        exGetSaveName(hWnd,szFileName);
		okSaveImageFile(hBoard,szFileName,0,BUFFER,0,1);
	}
}

void CGigeDemoDlg::OnReOpen() //ѡ
{
	// TODO: Add your control notification handler code here
	long			lParam = 0x3; //recheck 
	int				mBufRgbFrom = 0; //RGBʽ
	int             mAutoGain = 0; //Զ

    TotalBoard = okGetImageDevice(&lpOkDevInfo, (LPARAM)&lParam); //ӵok豸

	CSelectBoard showdlg; //ѡԻ
	showdlg.DoModal();
	
	MLONG iIndex = OpenBoardNo; 
	hBoard = okOpenBoard(&iIndex);	//

	if (hBoard)
	{
		/////////////////////////////////////////////////////пؼĳʼ
		m_mode = HIWORD(okSetVideoParam(hBoard, VIDEO_SIGNALTYPE, -1));//ģʽ0=1=ش2=崥3=ͬ
		if (m_mode)
		{
			GetDlgItem(IDC_SOFTTRIGGER)->EnableWindow(TRUE);
		}
		m_ccdgain = okSetVideoParam(hBoard, VIDEO_CONTRAST, -1); //
		m_brightness = okSetVideoParam(hBoard, VIDEO_BRIGHTNESS, -1);//ڵƽ	
		m_exposetime = okSetCaptureParam(hBoard, CAPTURE_EXPOSETIME, -1);//عʱ
		m_ipaddress.SetAddress(htonl(lpOkDevInfo[OpenBoardNo].iBoardIdentCode)); //ip
		mAutoGain = okSetCaptureParam(hBoard, CAPTURE_ENBCAMFUNC, -1); //Զ 0رգ1
		m_PacketSize = okSetCaptureParam(hBoard, CAPTURE_PACKETSIZE, -1); //С
		///////////////////////////////////////////////////////ɼĿ	
		rect.right = -1;
		okSetTargetRect(hBoard, BUFFER, &rect);
		m_width = rect.right - rect.left;
		m_height = rect.bottom - rect.top;		
		///////////////////////////////////////////////////////////////////////////RGBʽ
		mBufRgbFrom = LOWORD(okSetVideoParam(hBoard, VIDEO_RGBFORMAT, -1));	//õǰʽ	
		switch (mBufRgbFrom)
		{
		case FORM_GRAY8:
			m_bufform.SetCurSel(0);
			break;
		case FORM_GRAY10:
			m_bufform.SetCurSel(1);
			break;
		case FORM_GRAY12:
			m_bufform.SetCurSel(2);
			break;
		case FORM_GRAY14:
			m_bufform.SetCurSel(3);		
			break;
		case FORM_GRAY16:
			m_bufform.SetCurSel(4);
			break;
		default:
			break;	
		}		
		/////////////////////////////////////////////////////////////豸ͺ
		SetDlgItemText(IDC_TYPE, lpOkDevInfo[OpenBoardNo].szBoardName);

		GetDlgItem(IDC_ORGSET)->EnableWindow(TRUE);
		GetDlgItem(IDC_CAPTUREIMAGE)->EnableWindow(TRUE);
		GetDlgItem(IDC_SETPARAM)->EnableWindow(TRUE);
		GetDlgItem(IDC_SAVEIMAGE)->EnableWindow(TRUE);
		GetDlgItem(IDC_SAVETOMEMORY)->EnableWindow(TRUE);

	    UpdateData(FALSE);
	}
	else
	{
		MessageBox("ʧ", NULL, MB_OK);
	}
}

float exCalcCaptureRatio()///////////////////֡
{
	static	DWORD	times;
	if( (num>=12) ||  ((okGetTickCount()-times)>2000)&&(num>=2) ) 
	{
		times=okGetTickCount()-times;
		ratio=((float)num*1000/times);
		num=0;
	}
	
	if(num==0)
		times=okGetTickCount();
	num++;
	
	return ratio;
}

void CGigeDemoDlg::OnSoftTrigger()//ⴥ 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_mode==1)
	{
		if (bActive)
		{
			okPutSignalParam(hBoard, PUTSIGNAL_TRIGGER, MAKELONG(0,1));
		}
		else
		{
			OnCaptureImage();
			Sleep(1000);
			okPutSignalParam(hBoard, PUTSIGNAL_TRIGGER, MAKELONG(0,1));
		}
		
	}
	else
	{
		MessageBox("ûйشģʽĹģʽ",NULL,MB_OK);
	}
}

void CGigeDemoDlg::OnFieldchangedIpaddress1(NMHDR* pNMHDR, LRESULT* pResult) //IPռݱ仯
{
	// TODO: Add your control notification handler code here
    bSetIp = TRUE;
	*pResult = 0;
}

void CGigeDemoDlg::OnSavetomemory() //洢
{
	// TODO: Add your control notification handler code here
	okSetDeviceParam(hBoard, DEVICE_SETDEVMEMORY, 1);
}

void CGigeDemoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	int iWid = 0, iHgt = 0; //imageؼ
	
	if(iCx == 0 || iCy == 0)
    {
        iCx = cx;
        iCy = cy;
    }
    else if(cx == 0 && cy == 0)
    {
    }
	else if (bInitFinish)
	{
		m_image.GetClientRect(&rect); //õimageؼλ
		
		float systemratio, compareratio; //õĻֱ
        systemratio = (float)GetSystemMetrics(SM_CXSCREEN)/(float)GetSystemMetrics(SM_CYSCREEN);
        compareratio = (float)4.0/(float)3.0;
		
		if (systemratio > compareratio) //¼
		{
			iHgt = rect.bottom - rect.top - (iCy - cy);
			iWid = iHgt*4/3;
		}
		else
		{
			iWid = rect.right - rect.left - (iCx - cx);
			iHgt = iWid*3/4;
		}
		
        m_image.SetWindowPos(NULL,0,0,iWid,iHgt,SWP_NOMOVE); //imageؼλ
		
		iCx = cx;
		iCy = cy;		
	}
}
